<template>
  <el-select v-model="sortBy" placeholder="Ordre des taches">
    <el-option label="La plus récente" :key="defaultSortBy" :value="defaultSortBy" ></el-option>
    <el-option label="La plus ancienne" key="ascending" value="ascending" ></el-option>
  </el-select>

  <div v-for="dayTasks, dayTS in tasksByDay" :key="dayTS">
    <h3>{{ fullDateFormater.format(dayTS) }}</h3>
    <el-table
      :data="dayTasks"
      :row-class-name="checkHighlight"
      row-key="id"
      @row-click="setHighlight"
      empty-text="Aucune tache"
      style="width: 100%"
      v-loading="areTasksLoading"
      :ref="dayTS"
      >

      <el-table-column
        prop="name"
        sort-by="startTime"
        label="Tâche">
      </el-table-column>

      <el-table-column
        align="right"
        label="Début et fin"
        width="180">
        <template #header></template>
        <template #default="scope">
          {{ formatTimestamp(scope.row.startTime)}} - {{ formatTimestamp(scope.row.endTime)}}
        </template>
      </el-table-column>

      <el-table-column
        align="right"
        label="Durée"
        width="100">
        <template #header></template>
        <template #default="scope">
          {{ durationBetweenTimestamps(scope.row.startTime, scope.row.endTime)}}
        </template>
      </el-table-column>

      <el-table-column
        align="right"
        label="Actions"
        width="200">      
        <template #header></template>
        <template #default="scope">
          <TaskListActions 
            :taskID="scope.row.id" 
            :taskName="scope.row.name"
            />
        </template>
      </el-table-column>
      
    </el-table>
  </div>
  
</template>

<script>
  import { mapGetters, mapState } from 'vuex'
  import TaskListActions from './TaskListActions.vue'

  export default {
    components: {
      TaskListActions,
    },
    computed: {
      ... mapState({
        areTasksLoading : (state) => state.tasks.areTasksLoading
      }),
      ... mapGetters({
        tasksByDay : 'tasks/tasksByDay'
      })
    },
    data() {
      return {
        defaultSortBy: 'descending',
        fullDateFormater: Intl.DateTimeFormat('fr', { dateStyle : 'full'}),
        sortBy : (this.$route.query.sortBy === 'ascending') ? 'ascending' : 'descending',
        tsFormatter: Intl.DateTimeFormat('fr', { hour: '2-digit', minute: '2-digit' }),
      }
    },
    watch: {
      sortBy(newValue) {
        this.$router.replace({ query : { sortBy : (newValue === this.defaultSortBy ? undefined : newValue ) }})
        this.sortTable()
      },
      tasksByDay: {
        deep: true,
        handler() {
          this.$nextTick(() => {
            this.sortTable()
          })
        }
      }
    },
    methods: {
      checkHighlight({ row }) {
        if(this.$route.params.taskID && row.id === this.$route.params.taskID) {
          return 'highlight-line'
        }
        return ''
      },
      setHighlight(row) {
        this.$router.push({ path : '/home/' + row.id })
      },
      formatTimestamp (ts) {
        return this.tsFormatter.format(ts)
      },
      durationBetweenTimestamps (start, end) {
        let seconds = Math.floor((end / 1000) - (start / 1000))
        let minutes = Math.floor(seconds / 60)
        const hours = Math.floor(minutes / 60)
        seconds = seconds % 60
        minutes = minutes % 60
        return `${String(hours).padStart(2, '0')}:${String(minutes).padStart(2, '0')}:${String(seconds).padStart(2, '0')}`
      },
      sortTable() {
        for (let dayTS in this.tasksByDay) {
          this.$refs[dayTS].sort('name', this.sortBy)
        }
      }
    },
    mounted() {
      this.sortTable()  
    },
  }
</script>

<style scoped>
  .el-select {
    float: right;
  }

  h3 {
    text-align: left;
    text-transform: capitalize;
  }
</style>